package com.zipcodewilmington;

import java.util.Arrays;


/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {
        return array[array.length-1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        return array[array.length-2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        boolean result = false;

        for(String str:array){
            if(str.equals(value)){
                result = true;
                break;
            }
        }
        return result;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {

        String[] result = new String[array.length];
        int j = 0;

        for(int i = array.length-1; i>=0; i--){
            result[j] = array[i];
            j++;
        }
        return result;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        boolean result = true;
        int j = array.length-1;

        for(String str:array){
            if(!str.equals(array[j])){
                result = false;
            }
            j--;
        }
        return result;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        char[] alphabet = new char[26]; //string of alphabet characters
        alphabet[0] = 'a';
        for(int i = 0; i < 26; i++){
            alphabet[i] = (char) ('a'+ i);
        }

        boolean result = true; //beginning with default true statement

        StringBuilder sb = new StringBuilder();
        for(String str : array){
            sb.append(str.toLowerCase());
        }

        String arrStr = sb.toString();

        for(char letter: alphabet){
            if(!arrStr.contains(Character.toString(letter).toLowerCase())){
                result = false;
                break;
            }
        }

        return result;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int i = 0;
        for(String str : array){
            if(str.contains(value)){
                i++;
            }
        }
        return i;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        String[] arr2 = new String[array.length-1];
        int j = 0;

        for(int i=0; i<array.length; i++){
            if(array[i].equals(valueToRemove)){
                continue;
            }

            arr2[j] = array[i];
            j++;
        }

        return arr2;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        String lastWord = "";

        StringBuilder sb = new StringBuilder();
        for(String str : array){
            if(!str.equals(lastWord)) {
                sb.append(str + "-");
            }
            lastWord = str;
        }

        String[] arr2 = sb.toString().split("-");
        return arr2;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        StringBuilder sb = new StringBuilder(array[0]);
        String lastWord = array[0];

        for(int i=1; i<array.length; i++){
            if(!array[i].equals(lastWord)){
                sb.append("-");
            }
            sb.append(array[i]);
            lastWord = array[i];
        }

        String[] result = sb.toString().split("-");
        return result;
    }


}
